#!/usr/bin/octave -q
clear all; clc

args = argv();
if 1 ~= length(args)
	fprintf(stderr,'uso: procesa_problema problema'); exit
end
problema = char(args{1});

rand('state',0)   % inicializa a 0 o xerador de números aleatorios
kfold=4;
npc_min=5;
fprintf(stderr,'PROCESANDO PROBLEMA %s ...================================\n', problema);


% lectura de datos
cd(problema)
eval('le_datos')
cd ..

% preprocesamento de datos
en_supr=[];  #en_supr=entradas a suprimir por ser constantes
for i=1:ne
	t=x(:,i);media=mean(t);desv=std(t);
	if desv~=0
		x(:,i)=(t-media)/desv;
		if 2==nar
			t=x2(:,i);
			if 0~=desv
				x2(:,i)=(t-media)/desv;
			end
		end
	else
		fprintf('entrada %i constante\n',i);en_supr=[en_supr i];
	end
end

# supresión de entradas constantes
nes=length(en_supr);
if 0~=nes
	fprintf(stderr,'suprimidas %i entradas\n',nes)
	x(:,en_supr)=[];
	if 2==nar
		x2(:,en_supr)=[];
	end
	ne-=nes;
end

% suprime patróns iguais
repetidos=zeros(1,np);
for i=1:np
	if repetidos(i)==0
		t=x(i,:);
		for j=i+1:np
			if repetidos(i)==0 && all(t==x(j,:))
				repetidos(j)=1;
				fprintf(f,'suprimido patrón %i por estar repetido\n',j);
			end
		end
	end
end
rep=find(repetidos==1);nrep=length(rep);x(rep,:)=[];cl(rep)=[];np=size(x,1);

# almacena entradas e patróns suprimidos
if nes>0 || nrep>0
	nf=sprintf('%s/%s.log',problema,problema);
	f=fopen(nf,'w');
	if -1==f
		error('fopen %s',nf);
	end
	fprintf(f,'suprimida entrada %i por ser constante\n',en_supr)
	fprintf(f,'suprimida entrada %i por ser constante\n',rep)
	fclose(f);
end

% escribe a información do problema no ficheiro problema/problema.txt
fprintf(stderr,'escribindo %s.txt ...\n', problema)
nf=sprintf('%s/%s.txt', problema, problema);
f=fopen(nf, 'w');
if -1==f
  error('erro abrindo %s', nf)
end
fprintf(f,'np= %i\n', np);
fprintf(f,'ne= %i\n', ne);
fprintf(f,'nc= %i\n', nc);
fprintf(f,'nar= %i\n', nar);
if nar==2
	fprintf(f,'npt= %i\n',np2);
end
fprintf(f,'kfold= %i\n',kfold);
fclose(f);



% escrita de datos en formato R
nf = sprintf('%s/%s_R.dat', problema, problema);
fprintf(stderr,'escribindo %s ...\n',nf);
f=fopen(nf, 'w');
if -1==f
	error('erro abrindo %s', nf)
end
for i=1:ne
	fprintf(f, '\t%10s', sprintf('f%i',i));	
end
fprintf(f,'\tclase\n');
for i=1:np
	fprintf(stderr,'%5.1f%%\r', 100*i/np);
	fprintf(f, '%i\t', i);
	for j=1:ne
		fprintf(f, '%10.6f\t', x(i,j));
	end
	fprintf(f, '%i\n', cl(i));
end
fclose(f);

% escrita de datos en formato ARFF weka
nf = sprintf('%s/%s.arff', problema, problema);
fprintf(stderr,'escribindo %s ...\n',nf);
f=fopen(nf, 'w');
if -1==f
	error('erro abrindo %s', nf)
end
fprintf(f, sprintf('@relation %s\n', problema));
for i = 1:ne
	fprintf(f, "@attribute \'f%i\' real\n", i);
end
fprintf(f, "@attribute \'clase\' {");
for j=1:nc
	fprintf(f, '%i', j-1);
	if j < nc
		fprintf(f,',');
	end
end
fprintf(f, '}\n');
fprintf(f, '@data\n');
for i = 1:np
	fprintf(stderr,'%5.1f%%\r', 100*i/np);
	for j = 1:ne
		fprintf(f, '%10.6f,', x(i,j));
	end
	fprintf(f, '%i\n', cl(i)-1);
end
fclose(f);

% creación de particións
k2=(kfold-2)/kfold;ic=cell(1,nc);npc=zeros(1,nc);npce=zeros(1,nc);npcv=zeros(1,nc);npct=zeros(1,nc);
for i=1:nc
	ic{i}=find(cl==i);npc(i)=length(ic{i});
	if npc(i) < npc_min
		fprintf(stderr,'problema %s: a clase %i ten %i < %i patróns: conxuntos non xerados\n',problema,i,npc(i),npc_min)
		return;
	end
	npce(i)=ceil(k2*npc(i));npcv(i)=ceil((npc(i)-npce(i))/2);npct(i)=npc(i)-npce(i)-npcv(i);
	fprintf(stderr,'clase %i: np= %i npe= %i npv= %i npt=%i\n',i,npc(i),npce(i),npcv(i),npct(i));
end
npe=sum(npce);npv=sum(npcv);npt=sum(npct);

% barallamento
for i=1:nc
	n=npc(i);j=randperm(n);
	for k=1:n
		l=j(k);u=ic{i}(l);ic{i}(l)=ic{i}(k);ic{i}(k)=u;
	end
end

npcf=zeros(nc,kfold);k1=kfold-1;
for i=1:nc
	t=ceil(npc(i)/kfold);npcf(i,1:k1)=t;npcf(i,kfold)=npc(i)-k1*t;
	fprintf(stderr,'clase %i: npcf=',i);fprintf(stderr,'%i ',npcf(i,:));fprintf(stderr,'-> %i\n',sum(npcf(i,:)));
end
j=zeros(1,nc);

% escrita en conxuntos.dat
f = fopen(sprintf('%s/conxuntos.dat',problema), 'w');
if -1==f
	error('erro en fopen abrindo conxuntos.dat');
end
fprintf(f,'%i %i %i\n',npe,npv,npt);
for fold=1:kfold
	fprintf(stderr,'xerando fold %i ...\n',fold)
	f1=fold-1;
	for i=1:nc
		j(i)=min(npc(i),1+f1*npcf(i));
		for m=1:npce(i)
			k=j(i);fprintf(f,'%i ',ic{i}(k));j(i)=j(i)+1;
			if j(i)>npc(i)
				j(i)=1;
			end
		end
	end
	fprintf(f,'\n');
	for i=1:nc
		for m=1:npcv(i)
			k=j(i);fprintf(f,'%i ',ic{i}(k));j(i)=j(i)+1;
			if j(i)>npc(i)
				j(i)=1;
			end
		end
	end
	fprintf(f,'\n');
	for i=1:nc
		for m=1:npct(i)
			k=j(i);fprintf(f,'%i ',ic{i}(k));j(i)=j(i)+1;
			if j(i)>npc(i)
				j(i)=1;
			end
		end
	end
	fprintf(f,'\n');
end
fclose(f);

% verifica os datos e particións: tódalas clases deben ter patróns en tódolos conxuntos, e non pode haber patróns repetidos
fprintf(stderr,'verificando datos ...\n');
nf=sprintf('%s/conxuntos.dat',problema);
f=fopen(nf,'r');
if -1==f
	error('erro fopen %s',nf);
end
fscanf(f,'%i',3);
for i=1:kfold
	ie=fscanf(f,'%i',npe);iv=fscanf(f,'%i',npv);it=fscanf(f,'%i',npt);
	fprintf(stderr,'verificando fold %i ...\n',i);
	for j=1:nc   % busca clases baleiras en entrenamento/validación/teste
		if 0==sum(cl(ie)==j) fprintf(stderr,'clase %i ten 0 patróns de entrenamento\n',j); end
		if 0==sum(cl(iv)==j) fprintf(stderr,'clase %i ten 0 patróns de validación\n',j); end
		if 0==sum(cl(it)==j) fprintf(stderr,'clase %i ten 0 patróns de teste\n',j); end
	end
	% busca patróns de entrenamento/validación/teste repetidos
	for i=1:npe
		for j=1:npv
			if ie(i)==iv(j)
				fprintf(stderr,'patrón de entrenamento %i coincide con patrón de validación %i\n',ie(i),iv(j));
			end
		end
		for j=1:npt
			if ie(i)==it(j)
				fprintf(stderr,'patrón de entrenamento %i coincide con patrón de teste %i\n',ie(i),it(j));
			end
		end
	end
	for i=1:npv
		for j=1:npt
			if iv(i)==it(j)
				fprintf(stderr,'patrón de validación %i coincide con patrón de teste %i\n',iv(i),it(j));
			end
		end
	end
end
fclose(f);

# ---------------------------------------------------------------
# --- problema con dous arquivos de datos
# ---------------------------------------------------------------
if nar==2  %% PROCESAMENTO DE DATOS DE TESTE
	fprintf(stderr,'PROCESANDO DATOS DE TESTE ...\n');
	k2=(kfold-1)/kfold;ic=cell(1,nc);npc=zeros(1,nc);npce=zeros(1,nc);npcv=zeros(1,nc);
	for i=1:nc
		ic{i}=find(cl==i);npc(i)=length(ic{i});
%  		if npc(i) < npc_min
%  			fprintf(stderr,'problema %s teste: a clase %i ten %i < %i patróns: conxuntos non xerados\n',problema,i,npc(i),npc_min)
%  			return;
%  		end
		npce(i)=ceil(k2*npc(i));npcv(i)=npc(i)-npce(i);
		fprintf(stderr,'clase %i: np= %i npe= %i npv= %i\n',i,npc(i),npce(i),npcv(i));
	end
	npe=sum(npce);npv=sum(npcv);

	% barallamento
	for i=1:nc
		n=npc(i);j=randperm(n);
		for k=1:n
			l=j(k);u=ic{i}(l);ic{i}(l)=ic{i}(k);ic{i}(k)=u;
		end
	end

	npcf=zeros(nc,kfold);k1=kfold-1;
	for i=1:nc
		t=ceil(npc(i)/kfold);npcf(i,1:k1)=t;npcf(i,kfold)=npc(i)-k1*t;
		fprintf(stderr,'clase %i: npcf=',i);fprintf(stderr,'%i ',npcf(i,:));fprintf(stderr,'-> %i\n',sum(npcf(i,:)));
	end
	j=zeros(1,nc);

	% escrita en conxuntos_teste.dat
	f = fopen(sprintf('%s/conxuntos_teste.dat',problema), 'w');
	if -1==f
		error('erro en fopen abrindo conxuntos_teste.dat');
	end
	fprintf(f,'%i %i\n',npe,npv);
	for fold=1:kfold
		fprintf(stderr,'xerando fold %i ...\n',fold)
		f1=fold-1;
		for i=1:nc
			j(i)=min(npc(i),1+f1*npcf(i));
			for m=1:npce(i)
				k=j(i);fprintf(f,'%i ',ic{i}(k));j(i)=j(i)+1;
				if j(i)>npc(i)
					j(i)=1;
				end
			end
		end
		fprintf(f,'\n');
		for i=1:nc
			for m=1:npcv(i)
				k=j(i);fprintf(f,'%i ',ic{i}(k));j(i)=j(i)+1;
				if j(i)>npc(i)
					j(i)=1;
				end
			end
		end
		fprintf(f,'\n');
	end
	fclose(f);
	
	% escrita de datos de teste en formato R
	nf = sprintf('%s/%s_teste_R.dat', problema, problema);
	fprintf(stderr,'escribindo %s ...\n',nf);
	f=fopen(nf, 'w');
	if -1==f
		error('erro abrindo %s', nf)
	end
	for i=1:ne
		fprintf(f, '\t%10s', sprintf('f%i',i));	
	end
	fprintf(f,'\tclase\n');
	for i=1:np2
		fprintf(stderr,'%5.1f%%\r', 100*i/np2);
		fprintf(f, '%i\t', i);
		for j=1:ne
			fprintf(f, '%10.6f\t', x2(i,j));
		end
		fprintf(f, '%i\n', cl2(i));
	end
	fclose(f);

	% escrita de datos de teste en formato ARFF weka
	nf = sprintf('%s/%s_teste.arff', problema, problema);
	fprintf(stderr,'escribindo %s ...\n',nf);
	f=fopen(nf, 'w');
	if -1==f
		error('erro abrindo %s', nf)
	end
	fprintf(f, sprintf('@relation %s\n', problema));
	for i = 1:ne
		fprintf(f, "@attribute \'f%i\' real\n", i);
	end
	fprintf(f, "@attribute \'clase\' {");
	for j=1:nc
		fprintf(f, '%i', j-1);
		if j < nc
			fprintf(f,',');
		end
	end
	fprintf(f, '}\n');
	fprintf(f, '@data\n');
	for i = 1:np2
		fprintf(stderr,'%5.1f%%\r', 100*i/np2);
		for j = 1:ne
			fprintf(f, '%10.6f,', x2(i,j));
		end
		fprintf(f, '%i\n', cl2(i)-1);
	end
	fclose(f);

	% verifica os datos e particións: tódalas clases deben ter patróns en tódolos conxuntos, e non pode haber patróns repetidos
	fprintf(stderr,'verificando datos ...\n');
	nf=sprintf('%s/conxuntos_teste.dat',problema);
	f=fopen(nf,'r');
	if -1==f
		error('erro fopen %s',nf);
	end
	fscanf(f,'%i',2);
	for i=1:kfold
		ie=fscanf(f,'%i',npe);iv=fscanf(f,'%i',npv);
		fprintf(stderr,'verificando fold %i ...\n',i);
		for j=1:nc   % busca clases baleiras en entrenamento/validación
			if 0==sum(cl(ie)==j) fprintf(stderr,'clase %i ten 0 patróns de entrenamento\n',j); end
			if 0==sum(cl(iv)==j) fprintf(stderr,'clase %i ten 0 patróns de validación\n',j); end
		end
		% busca patróns de entrenamento/validación/teste repetidos
		for i=1:npe
			for j=1:npv
				if ie(i)==iv(j)
					fprintf(stderr,'patrón de entrenamento %i coincide con patrón de validación %i\n',ie(i),iv(j));
				end
			end
		end
	end
	fclose(f);

end
fprintf(stderr,'rematado procesamento de problema %s\n', problema);



%  % escribe a matriz de coste de clase para CostSensitiveClassifier e MetaCost de weka
%  fprintf(stderr,'escribindo %s.cost ...\n', problema)
%  nf=sprintf('%s/%s.cost', problema, problema);
%  f=fopen(nf, 'w');
%  if -1==f
%    error('erro abrindo %s', nf)
%  end
%  fprintf(f,'%% Rows\tColumns\n%i\t%i\n%% Matrix elements\n', nc, nc)
%  for i=1:nc
%    for j=1:nc
%  		if j==i
%  			fprintf(f, ' 0.0\t');
%  		else
%  			fprintf(f, ' 1.0\t');
%  		end
%    end
%    fprintf(f, '\n');
%  end
%  fclose(f);
