#!/usr/bin/octave -q
clc

args = argv();
if 1 ~= length(args)
	fprintf(stderr,'uso: procesa_problema problema'); exit
end
problema = char(args{1});

%  problema='image-segmentation';

rand('state',0)   % inicializa a 0 o xerador de números aleatorios
kfold=4;
npc_min=5;
fprintf(stderr,'procesando problema %s ...\n', problema);


% lectura de datos
cd(problema)
eval('le_datos')
cd ..

% preprocesamento de datos
media=zeros(1,ne); desv=zeros(1,ne);
for i=1:ne
	media(i)=mean(x(:,i));desv(i)=std(x(:,i));
	if desv(i) ~= 0
		x(:,i)=(x(:,i) - media(i))/desv(i);
	end
end

% suprime patróns iguais
repetidos=zeros(1,np);
for i=1:np
	if repetidos(i)==0
		t=x(i,:);
		for j=i+1:np
			if repetidos(i)==0 && all(t==x(j,:))
				repetidos(j)=1;
			end
		end
	end
end
rep=find(repetidos==1);x(rep,:)=[];cl(rep)=[];np=size(x,1);


% escribe a información do problema no ficheiro problema/problema.txt
fprintf(stderr,'escribindo %s.txt ...\n', problema)
nf=sprintf('%s/%s.txt', problema, problema);
f=fopen(nf, 'w');
if -1==f
  error('erro abrindo %s', nf)
end
fprintf(f,'np= %i\n', np);
fprintf(f,'ne= %i\n', ne);
fprintf(f,'nc= %i\n', nc);
fprintf(f,'nar= %i\n', nar);
if nar==2
	fprintf(f,'npt= %i\n',npt);
end
fprintf(f,'kfold= %i\n',kfold);
fclose(f);



% escrita de datos en formato R
nf = sprintf('%s/%s_R.dat', problema, problema);
fprintf(stderr,'escribindo %s ...\n',nf);
f=fopen(nf, 'w');
if -1==f
	error('erro abrindo %s', nf)
end
for i=1:ne
	fprintf(f, '\t%10s', sprintf('f%i',i));	
end
fprintf(f,'\tclase\n');
for i=1:np
	fprintf(stderr,'%5.1f%%\r', 100*i/np);
	fprintf(f, '%i\t', i);
	for j=1:ne
		fprintf(f, '%10.6f\t', x(i,j));
	end
	fprintf(f, '%i\n', cl(i));
end
fclose(f);

% escrita de datos en formato ARFF weka
nf = sprintf('%s/%s.arff', problema, problema);
fprintf(stderr,'escribindo %s ...\n',nf);
f=fopen(nf, 'w');
if -1==f
	error('erro abrindo %s', nf)
end
fprintf(f, sprintf('@relation %s\n', problema));
for i = 1:ne
	fprintf(f, "@attribute \'f%i\' real\n", i);
end
fprintf(f, "@attribute \'clase\' {");
for j=1:nc
	fprintf(f, '%i', j-1);
	if j < nc
		fprintf(f,',');
	end
end
fprintf(f, '}\n');
fprintf(f, '@data\n');
for i = 1:np
	fprintf(stderr,'%5.1f%%\r', 100*i/np);
	for j = 1:ne
		fprintf(f, '%10.6f,', x(i,j));
	end
	fprintf(f, '%i\n', cl(i)-1);
end
fclose(f);

% creación de particións
k2=(kfold-2)/kfold;ic=cell(1,nc);npc=zeros(1,nc);npce=zeros(1,nc);npcv=zeros(1,nc);npct=zeros(1,nc);
for i=1:nc
	ic{i}=find(cl==i);npc(i)=length(ic{i});
	if npc(i) < npc_min
		fprintf(stderr,'problema %s: a clase %i ten %i < %i patróns: conxuntos non xerados\n',problema,i,npc(i),npc_min)
		return;
	end
	npce(i)=ceil(k2*npc(i));npcv(i)=ceil((npc(i)-npce(i))/2);npct(i)=npc(i)-npce(i)-npcv(i);
	fprintf(stderr,'clase %i: np= %i npe= %i npv= %i npt=%i\n',i,npc(i),npce(i),npcv(i),npct(i));
end
npe=sum(npce);npv=sum(npcv);npt=sum(npct);

% barallamento
for i=1:nc
	n=npc(i);j=randperm(n);
	for k=1:n
		l=j(k);u=ic{i}(l);ic{i}(l)=ic{i}(k);ic{i}(k)=u;
	end
end

npcf=zeros(nc,kfold);k1=kfold-1;
for i=1:nc
	t=ceil(npc(i)/kfold);npcf(i,1:k1)=t;npcf(i,kfold)=npc(i)-k1*t;
	fprintf(stderr,'clase %i: npcf=',i);fprintf(stderr,'%i ',npcf(i,:));fprintf(stderr,'-> %i\n',sum(npcf(i,:)));
end
j=zeros(1,nc);

% escrita en conxuntos.dat
f = fopen(sprintf('%s/conxuntos.dat',problema), 'w');
if -1==f
	error('erro en fopen abrindo conxuntos.dat');
end
fprintf(f,'%i %i %i\n',npe,npv,npt);
for fold=1:kfold
	fprintf(stderr,'xerando fold %i ...\n',fold)
	f1=fold-1;
	for i=1:nc
		j(i)=min(npc(i),1+f1*npcf(i));
		for m=1:npce(i)
			k=j(i);fprintf(f,'%i ',ic{i}(k));j(i)=j(i)+1;
			if j(i)>npc(i)
				j(i)=1;
			end
		end
	end
	fprintf(f,'\n');
	for i=1:nc
		for m=1:npcv(i)
			k=j(i);fprintf(f,'%i ',ic{i}(k));j(i)=j(i)+1;
			if j(i)>npc(i)
				j(i)=1;
			end
		end
	end
	fprintf(f,'\n');
	for i=1:nc
		for m=1:npct(i)
			k=j(i);fprintf(f,'%i ',ic{i}(k));j(i)=j(i)+1;
			if j(i)>npc(i)
				j(i)=1;
			end
		end
	end
	fprintf(f,'\n');
end
fclose(f);

% verifica os datos e particións: tódalas clases deben ter patróns en tódolos conxuntos, e non pode haber patróns repetidos
fprintf(stderr,'verificando datos ...\n');
nf=sprintf('%s/conxuntos.dat',problema);
f=fopen(nf,'r');
if -1==f
	error('erro fopen %s',nf);
end
fscanf(f,'%i',3);
for i=1:kfold
	ie=fscanf(f,'%i',npe);iv=fscanf(f,'%i',npv);it=fscanf(f,'%i',npt);
	fprintf(stderr,'analizando fold %i ...\n',i);
	for j=1:nc   % busca clases baleiras en entrenamento/validación/teste
		if 0==sum(cl(ie)==j) fprintf(stderr,'clase %i ten 0 patróns de entrenamento\n',j); end
		if 0==sum(cl(iv)==j) fprintf(stderr,'clase %i ten 0 patróns de validación\n',j); end
		if 0==sum(cl(it)==j) fprintf(stderr,'clase %i ten 0 patróns de teste\n',j); end
	end
	% busca patróns de entrenamento/validación/teste repetidos
	for i=1:npe
		for j=1:npv
			if ie(i)==iv(j)
				fprintf(stderr,'patrón de entrenamento %i coincide con patrón de validación %i\n',ie(i),iv(j));
			end
		end
		for j=1:npt
			if ie(i)==it(j)
				fprintf(stderr,'patrón de entrenamento %i coincide con patrón de teste %i\n',ie(i),it(j));
			end
		end
	end
	for i=1:npv
		for j=1:npt
			if iv(i)==it(j)
				fprintf(stderr,'patrón de validación %i coincide con patrón de teste %i\n',iv(i),it(j));
			end
		end
	end
end
fclose(f);

fprintf(stderr,'rematado procesamento de problema %s\n', problema);
